import Vue from 'vue'
import Vuex from 'vuex'
import _ from 'lodash'

Vue.use(Vuex)

function getRandomInt(min, max) {
  min = Math.ceil(min)
  max = Math.floor(max)
  return Math.floor(Math.random() * (max - min + 1)) + min
}

var files = {
  'test-1': {id: 0, title: 'test 1', contents: '= test 1', slug: 'test-1', tags: ['a']},
  'test-2': {id: 1, title: 'test 2', contents: '= test 2', slug: 'test-2', tags: ['b']},
  'test-3': {id: 2, title: 'test 3', contents: '= test 3', slug: 'test-3', tags: ['a','b']},
  'test-4': {id: 3, title: 'test 4', contents: '= test 4', slug: 'test-4', tags: ['c']}
}

export default new Vuex.Store({
  state: {
    errs: []
  },
  mutations: {
    clearError(state) {
      state.errs = []
    },
    addError(state, err) {
      state.errs.push(err)
    }
  },
  actions: {
    getFile: function(_, slug) {
      console.log('getFile('+slug+')')
      return new Promise(function (resolve) {
        setTimeout(() => resolve(files[slug]), getRandomInt(0, 1000))
      })
    },
    getSearchResults: function (state, query) {
      console.log('getSearchResults: '+query)
      let values = Object.values(files)
      if (query)
        values = _.filter(values, (o) => {
          return o.title.indexOf(query) != -1
        })
      return new Promise(function (resolve) {
        setTimeout(() => resolve(values, getRandomInt(0, 1000)))
      })
    }
  },
  modules: {
  }
})
